
XIncludeFile "Container.pb"


Interface Stack
  front.i()
  push.i(*element=#Null)
  pop.i()
  isEmpty.i()
  clear.i()
  free.i()
EndInterface


Macro InitStack(_type_, _container_=List)
  DisableDebugger
  
  
  InitContainer(_type_, _container_)
  
  CompilerIf Not Defined(Stack#_type_, #PB_Structure)
    
    Structure Stack#_type_ Extends CNStructure(_type_, _container_)
    EndStructure
    
    
    ;- Stack_front
    Procedure Stack#_type_#_front(*this.Stack#_type_)
      Protected *res
      
      CNGet(*res, _container_)
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- Stack_push
    Procedure Stack#_type_#_push(*this.Stack#_type_, *element=#Null)
      Protected *res
      
      CNAdd(*res, _type_, _container_)
      
      If (*element <> #Null)
        CopyStructure(*element, *res, _type_)
      EndIf
      
      ProcedureReturn *res
    EndProcedure
    
    
    ;- Stack_pop
    Procedure Stack#_type_#_pop(*this.Stack#_type_)
      CNDel(_type_, _container_)
    EndProcedure
    
    
    ;- Stack_isEmpty
    Procedure Stack#_type_#_isEmpty(*this.Stack#_type_)
      Protected size
      
      CNSize(size, _container_)
      
      ProcedureReturn Bool(size = 0)
    EndProcedure
    
    
    ;- Stack_clear
    Procedure Stack#_type_#_clear(*this.Stack#_type_)
      CNClear(_type_, _container_)
    EndProcedure
    
    
    ;- Stack_free
    Procedure Stack#_type_#_free(*this.Stack#_type_)
      FreeStructure(*this)
    EndProcedure
    
    
    ;- NewStack
    Procedure NewStack#_type_(*this.Stack#_type_ = #Null)
      If (*this = #Null)
        *this = AllocateStructure(Stack#_type_)
      EndIf
      *this\VTable = ?Functions
      
      DataSection
        Functions:
        Data.i @Stack#_type_#_front()
        Data.i @Stack#_type_#_push()
        Data.i @Stack#_type_#_pop()
        Data.i @Stack#_type_#_isEmpty()
        Data.i @Stack#_type_#_clear()
        Data.i @Stack#_type_#_free()
      EndDataSection
      
      ProcedureReturn *this
    EndProcedure
    
  CompilerEndIf
  
  EnableDebugger
EndMacro


Macro NewStack(_type_, _this_ = #Null)
  NewStack#_type_(_this_)
EndMacro


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = -
; EnableXP