
XIncludeFile "TreeMap.pb"


Interface TreeSet
  size.i()
  isEmpty.i()
  add.i(*value, *isAdd.Integer=#Null)
  getValue.i(*value)
  contains.i(*value)
  delete.i(*value)
  deleteThis.i(*value)
  reset.i()
  prevEl.i(*pointer.Integer=#Null)
  nextEl.i(*pointer.Integer=#Null)
  getCurrent.i()
  setCurrent.i(*value)
  clear.i()
  free.i()
EndInterface


Macro InitTreeSet(_type_)
  DisableDebugger
  
  InitTreeMap(_type_, Void)
  
  
  CompilerIf Not Defined(TreeSet#_type_, #PB_Structure)
    
    Structure TreeSet#_type_ Extends TreeMap#_type_#Void
    EndStructure
    
    
    ;- TreeSet_add
    Procedure TreeSet#_type_#_add(*this.TreeSet#_type_, *value, *isAdd.Integer=#Null)
      ProcedureReturn TreeMap#_type_#Void_put(*this, *value, #Null, *isAdd)
    EndProcedure
    
    
    ;- TreeSet_deleteThis
    Procedure TreeSet#_type_#_deleteThis(*this.TreeSet#_type_, *value)
      Protected *entry
      
      *entry = *value - OffsetOf(TreeMapEntry#_type_#Void\key)
      ProcedureReturn TreeMap#_type_#Void_deleteEntry(*this, *value)
    EndProcedure
    
    
    ;- TreeSet_setCurrent
    Procedure TreeSet#_type_#_setCurrent(*this.TreeSet#_type_, *value)
      Protected *entry
      
      *entry = *value - OffsetOf(TreeMapEntry#_type_#Void\key)
      TreeMap#_type_#Void_setCurrentEntry(*this, *entry)
    EndProcedure
    
    
    ;- NewTreeSet
    Procedure NewTreeSet#_type_(*compare.Comparator, *this.TreeSet#_type_ = #Null)
      If (*this = #Null)
        *this = AllocateStructure(TreeSet#_type_)
      EndIf
      *this\VTable  = ?Functions
      *this\compare = *compare
      
      DataSection
        Functions:
        Data.i @TreeMap#_type_#Void_size()
        Data.i @TreeMap#_type_#Void_isEmpty()
        Data.i @TreeSet#_type_#_add()
        Data.i @TreeMap#_type_#Void_getKey()        ; getValue
        Data.i @TreeMap#_type_#Void_contains()
        Data.i @TreeMap#_type_#Void_delete()
        Data.i @TreeSet#_type_#_deleteThis()
        Data.i @TreeMap#_type_#Void_reset()         ; reset
        Data.i @TreeMap#_type_#Void_prevKey()       ; prevEl
        Data.i @TreeMap#_type_#Void_nextKey()       ; nextEl
        Data.i @TreeMap#_type_#Void_getCurrentKey() ; getCurrent
        Data.i @TreeSet#_type_#_setCurrent()
        Data.i @TreeMap#_type_#Void_clear()
        Data.i @TreeMap#_type_#Void_free()
      EndDataSection
      
      ProcedureReturn *this
    EndProcedure
    
  CompilerEndIf
  
  EnableDebugger
EndMacro


Macro NewTreeSet(_type_, _compare_, _this_ = #Null))
  NewTreeSet#_type_(_compare_, _this_)
EndMacro


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = -
; EnableXP